"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from orq_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from orq_ai_sdk.utils import FieldMetadata, PathParamMetadata, QueryParamMetadata
import pydantic
from pydantic import model_serializer
from typing import Dict, List, Literal, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


QueryParamStatusTypedDict = TypeAliasType(
    "QueryParamStatusTypedDict", Union[List[str], str]
)
r"""Filter datasources by status."""


QueryParamStatus = TypeAliasType("QueryParamStatus", Union[List[str], str])
r"""Filter datasources by status."""


class ListChunksRequestTypedDict(TypedDict):
    knowledge_id: str
    r"""The unique identifier of the knowledge base"""
    datasource_id: str
    r"""The unique identifier of the datasource."""
    limit: NotRequired[float]
    r"""A limit on the number of objects to be returned. Limit can range between 1 and 50, and the default is 10"""
    starting_after: NotRequired[str]
    r"""A cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, ending with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `after=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the next page of the list."""
    ending_before: NotRequired[str]
    r"""A cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, starting with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `before=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the previous page of the list."""
    q: NotRequired[str]
    r"""Search query to find datasources by name."""
    status: NotRequired[QueryParamStatusTypedDict]
    r"""Filter datasources by status."""


class ListChunksRequest(BaseModel):
    knowledge_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The unique identifier of the knowledge base"""

    datasource_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The unique identifier of the datasource."""

    limit: Annotated[
        Optional[float],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = 10
    r"""A limit on the number of objects to be returned. Limit can range between 1 and 50, and the default is 10"""

    starting_after: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""A cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, ending with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `after=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the next page of the list."""

    ending_before: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""A cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 20 objects, starting with `01JJ1HDHN79XAS7A01WB3HYSDB`, your subsequent call can include `before=01JJ1HDHN79XAS7A01WB3HYSDB` in order to fetch the previous page of the list."""

    q: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Search query to find datasources by name."""

    status: Annotated[
        Optional[QueryParamStatus],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Filter datasources by status."""


ListChunksObject = Literal["list"]

ListChunksMetadataTypedDict = TypeAliasType(
    "ListChunksMetadataTypedDict", Union[str, float, bool]
)


ListChunksMetadata = TypeAliasType("ListChunksMetadata", Union[str, float, bool])


ListChunksStatus = Literal["pending", "processing", "completed", "failed", "queued"]
r"""The status of the chunk"""


class ListChunksDataTypedDict(TypedDict):
    id: str
    r"""The unique identifier of the chunk"""
    text: str
    r"""The text content of the chunk"""
    enabled: bool
    r"""Whether the chunk is enabled"""
    status: ListChunksStatus
    r"""The status of the chunk"""
    created: str
    r"""The date and time the chunk was created"""
    updated: str
    r"""The date and time the chunk was updated"""
    metadata: NotRequired[Dict[str, ListChunksMetadataTypedDict]]
    r"""Metadata of the chunk. Can include `page_number` or any other key-value pairs"""
    created_by_id: NotRequired[Nullable[str]]
    r"""The unique identifier of the user who created the chunk"""
    update_by_id: NotRequired[Nullable[str]]
    r"""The unique identifier of the user who updated the chunk"""


class ListChunksData(BaseModel):
    id: Annotated[str, pydantic.Field(alias="_id")]
    r"""The unique identifier of the chunk"""

    text: str
    r"""The text content of the chunk"""

    enabled: bool
    r"""Whether the chunk is enabled"""

    status: ListChunksStatus
    r"""The status of the chunk"""

    created: str
    r"""The date and time the chunk was created"""

    updated: str
    r"""The date and time the chunk was updated"""

    metadata: Optional[Dict[str, ListChunksMetadata]] = None
    r"""Metadata of the chunk. Can include `page_number` or any other key-value pairs"""

    created_by_id: OptionalNullable[str] = UNSET
    r"""The unique identifier of the user who created the chunk"""

    update_by_id: OptionalNullable[str] = UNSET
    r"""The unique identifier of the user who updated the chunk"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["metadata", "created_by_id", "update_by_id"]
        nullable_fields = ["created_by_id", "update_by_id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class ListChunksResponseBodyTypedDict(TypedDict):
    r"""Chunks successfully retrieved"""

    object: ListChunksObject
    data: List[ListChunksDataTypedDict]
    has_more: bool


class ListChunksResponseBody(BaseModel):
    r"""Chunks successfully retrieved"""

    object: ListChunksObject

    data: List[ListChunksData]

    has_more: bool
