"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from orq_ai_sdk.types import BaseModel
from typing import List, Literal
from typing_extensions import TypedDict


ListModelsObject = Literal["list"]

ListModelsType = Literal[
    "chat",
    "completion",
    "embedding",
    "vision",
    "image",
    "tts",
    "stt",
    "rerank",
    "moderations",
]
r"""The modality of the model"""

OwnedBy = Literal["vendor", "workspace"]
r"""Describe the provider of the model. Every model with `vendor` is publicly available, while models with `workspace` are private."""


class ListModelsDataTypedDict(TypedDict):
    r"""Describes a model offering that can be used with the API"""

    id: str
    r"""The model identifier, which can be referenced in the API endpoints."""
    created: float
    r"""The timestamp of the model creation"""
    type: ListModelsType
    r"""The modality of the model"""
    owned_by: OwnedBy
    r"""Describe the provider of the model. Every model with `vendor` is publicly available, while models with `workspace` are private."""


class ListModelsData(BaseModel):
    r"""Describes a model offering that can be used with the API"""

    id: str
    r"""The model identifier, which can be referenced in the API endpoints."""

    created: float
    r"""The timestamp of the model creation"""

    type: ListModelsType
    r"""The modality of the model"""

    owned_by: OwnedBy
    r"""Describe the provider of the model. Every model with `vendor` is publicly available, while models with `workspace` are private."""


class ListModelsResponseBodyTypedDict(TypedDict):
    r"""A list of model objects."""

    object: ListModelsObject
    data: List[ListModelsDataTypedDict]
    has_more: bool


class ListModelsResponseBody(BaseModel):
    r"""A list of model objects."""

    object: ListModelsObject

    data: List[ListModelsData]

    has_more: bool
